head	1.9;
access;
symbols;
locks; strict;
comment	@ * @;


1.9
date	94.11.10.01.50.55;	author rushing;	state Exp;
branches;
next	1.8;

1.8
date	94.11.10.01.27.43;	author rushing;	state Exp;
branches;
next	1.7;

1.7
date	94.11.09.23.01.00;	author rushing;	state Exp;
branches;
next	1.6;

1.6
date	94.11.02.01.51.44;	author jcooper;	state Exp;
branches;
next	1.5;

1.5
date	94.09.18.22.42.58;	author jcooper;	state Exp;
branches;
next	1.4;

1.4
date	94.09.16.01.12.35;	author jcooper;	state Exp;
branches;
next	1.3;

1.3
date	94.08.11.00.11.55;	author jcooper;	state Exp;
branches;
next	1.2;

1.2
date	94.05.23.18.36.00;	author jcooper;	state Exp;
branches;
next	1.1;

1.1
date	94.01.16.12.12.47;	author jcoop;	state Exp;
branches;
next	;


desc
@jcoop's block mem mgmt routines, alternative to MRR's block/doc paradigm
@


1.9
log
@removed logs
@
text
@/********************************************************************
 *                                                                  *
 *  MODULE    :  WVTXTBLK.C                                         *
 *                                                                  *
 *  PURPOSE   : This file contains Memory Management routines for   *
 *		text blocks                                         *                                 
 *                                                                  *
 *              The TypTextBlock struct is defined in wvglob.h      *
 *                                                                  *
 * Author: John S. Cooper (jcooper@@netcom.com)                      *
 *   Date: Sept 30, 1993                                            *
 ********************************************************************/

/* 
 * $Id: wvtxtblk.c 1.8 1994/11/10 01:27:43 rushing Exp rushing $
 */

#include <windows.h>
#include <windowsx.h>
#include "wvglob.h"
#include "winvn.h"
#pragma hdrstop
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define BLOCK_NUM_LINES_INC	64L
#define TEXT_SIZE_INC		1024L

// Private functions
BOOL IncreaseTextSize (TypTextBlock * textBlock, unsigned long inc);
BOOL AllocTextBlock (TypTextBlock * textBlock, unsigned long bytes, unsigned long lines);

/* ------------------------------------------------------------------------
 *    Mem Management routines for text block
 *  This is my simple alternative M. Riordan's Doc paradigm
 */
BOOL
AllocTextBlock (TypTextBlock * textBlock, unsigned long bytes, unsigned long lines)
{
  textBlock->maxLines = lines;
  if ((textBlock->offset = (unsigned long huge *) GlobalAllocPtr (GMEM_MOVEABLE, textBlock->maxLines * sizeof (unsigned long huge))) == NULL) {
//      MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Create-Offsets", MB_OK);
	return (FAIL);
  }
  textBlock->numLines = 0;

  textBlock->maxBytes = bytes;
  if ((textBlock->text = (char huge *) GlobalAllocPtr (GMEM_MOVEABLE, textBlock->maxBytes * sizeof (char huge))) == NULL) {
//      MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Create-Text", MB_OK);
	GlobalFreePtr (textBlock->offset);
	return (FAIL);
  }
  textBlock->numBytes = 0;
  textBlock->maxLineLen = 0;
  return (SUCCESS);
}

/* InitTextBlockWithSize will not give an error message if it can't allocate
 * the data.  It will return NULL, so the caller can provide an alternate
 * solution (i.e. text-block-to-disk)
 */
TypTextBlock *
InitTextBlockWithSize (HWND hParentWnd, unsigned long bytes, unsigned long lines)
{
  TypTextBlock *textBlock;

  if ((textBlock = (TypTextBlock *) GlobalAllocPtr (GMEM_MOVEABLE, sizeof (TypTextBlock))) == NULL) {
	MessageBox (hParentWnd, "Memory Allocation Failure", "Text Block Create-Block", MB_OK);
	return (NULL);
  }
  textBlock->hTextWnd = hParentWnd;
  textBlock->IsBusy = TRUE;
  if (AllocTextBlock (textBlock, bytes, lines) == FAIL) {
	GlobalFreePtr (textBlock);
	return (NULL);
  }

  return (textBlock);
}

TypTextBlock *
InitTextBlock (HWND hParentWnd)
{
  TypTextBlock *textBlock;

  if ((textBlock = InitTextBlockWithSize (hParentWnd, TEXT_SIZE_INC, BLOCK_NUM_LINES_INC)) == NULL) {
	MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Creation", MB_OK);
	return (NULL);
  }

  return (textBlock);
}

void
ResetTextBlock (TypTextBlock * textBlock)
{
  GlobalFreePtr (textBlock->text);
  GlobalFreePtr (textBlock->offset);
  AllocTextBlock (textBlock, TEXT_SIZE_INC, BLOCK_NUM_LINES_INC);
}

void
FreeTextBlock (TypTextBlock * textBlock)
{
  GlobalFreePtr (textBlock->text);
  GlobalFreePtr (textBlock->offset);
  GlobalFreePtr (textBlock);
}

BOOL
AddLineToTextBlock (TypTextBlock * textBlock, char *line)
{
  unsigned int len;
  unsigned long nextSeg;

  if (line == NULL || *line == '\0')
	return (SUCCESS);

  // manage offset list
  if (textBlock->numLines + 1 >= textBlock->maxLines) {
	textBlock->maxLines += BLOCK_NUM_LINES_INC;
	if ((textBlock->offset = (unsigned long huge *) GlobalReAllocPtr (textBlock->offset,
																	  textBlock->maxLines * sizeof (unsigned long huge), GMEM_MOVEABLE)) == NULL) {
	  MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Add-Offsets", MB_OK);
	  return (FAIL);
	}
  }

  // manage text string
  len = strlen (line) + 1;		// include the NULL in the count

  if (textBlock->numBytes + len >= textBlock->maxBytes)
	if (IncreaseTextSize (textBlock, max (len, TEXT_SIZE_INC)) == FAIL)
	  return (FAIL);

  // check if this line would cause text to cross a 64k segment
  // if so, fill in with nulls, and start new line at next seg 
  // WHY DO I HAVE TO DO THIS?!?!? Windows is supposed to take
  // care of this isn't it?!  memcpy is supposed to work with huge
  nextSeg = ((textBlock->numBytes + 65536L) / 65536L) * 65536L;
  if (textBlock->numBytes + len > nextSeg) {
	if (nextSeg + len > textBlock->maxBytes)	// do we need to add some space?

	  if (IncreaseTextSize (textBlock, max (nextSeg - textBlock->numBytes, TEXT_SIZE_INC)) == FAIL)
		return (FAIL);
	while (textBlock->numBytes < nextSeg)
	  textBlock->text[(textBlock->numBytes)++] = '\0';
  }
  // set pointer offset to this new string
  textBlock->offset[textBlock->numLines] = textBlock->numBytes;

  // copy it in, including the NULL
  memcpy ((char huge *) &(textBlock->text[textBlock->numBytes]), line, len);

  // increment counters
  textBlock->numLines++;
  textBlock->numBytes += (unsigned long) len;

  // save max string len for use in scroll bar ranges in status wnd
  if (len > textBlock->maxLineLen)
	textBlock->maxLineLen = len;

  return (SUCCESS);
}

BOOL
IncreaseTextSize (TypTextBlock * textBlock, unsigned long inc)
{
  textBlock->maxBytes += inc;
  if ((textBlock->text = (char huge *) GlobalReAllocPtr (textBlock->text,
		textBlock->maxBytes * sizeof (char huge), GMEM_MOVEABLE)) == NULL) {
	MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Add-Text", MB_OK);
	return (FAIL);
  }
}
/* ------------------------------------------------------------------------
 * AddEndedLineToAttach
 * Front end to AddLineToTextBlock which sets the end-of-line chars
 * Also, if posting and first char is '.', change it to '..'
 * To add blank line, send line parameter as ""
 */
BOOL
AddEndedLineToTextBlock (TypTextBlock * textBlock, char *line)
{
  char *new, *ptr;
  unsigned int len;
  BOOL result;

  len = strcspn (line, "\n\r");
  ptr = new = (char *) GlobalAllocPtr (GMEM_MOVEABLE, (len + 4) * sizeof (char));
  if (ptr == NULL) {
	return (FAIL);
  }
//  if (mode == ADD_TO_POST && line[0] == '.')
  //      *(ptr++) = '.';

  if (len > 0)
	memcpy (ptr, line, len);

  ptr[len++] = '\r';
  ptr[len++] = '\n';
  ptr[len] = '\0';

  result = AddLineToTextBlock (textBlock, new);
  GlobalFreePtr (new);
  return (result);
}

/* ------------------------------------------------------------------------
 * ReadFileToTextBlock
 * Reads text file into text block
 * File must be all ASCII
 */
BOOL
ReadFileToTextBlock (HWND hParentWnd, TypTextBlock * block, char *fileName)
{
  register int i;
  TypMRRFile *MRRFile;
  HFILE hFile;
  int numRead, result;
  char mybuf[TEMPBUFSIZE];
  BOOL leadingBlanks;

  hFile = MRROpenFile (fileName, OF_READ, &MRRFile);
  if (hFile <= 0) {
	sprintf (str, "Could not open file %s for read", fileName);
	MessageBox (hParentWnd, str, "Open File Error", MB_OK);
	return (FAIL);
  }
  else {
	CodingState = ATTACH_READFILE;
	leadingBlanks = TRUE;
	result = SUCCESS;
	while ((numRead = MRRReadLine (MRRFile, mybuf, TEMPBUFSIZE)) > -1) {
	  mybuf[numRead] = '\0';
	  if (leadingBlanks) {		// skip leading blank lines

		if (IsBlankStr (mybuf))
		  continue;
		else
		  leadingBlanks = FALSE;
	  }

	  for (i = 0; i < numRead; i++) {
		if (!__isascii (mybuf[i])) {
		  sprintf (str, "File %s appears to contain non-ASCII data.\nBinary files must be encoded for attachment", fileName);
		  MessageBox (hParentWnd, str, "Non-ASCII File Error", MB_OK);
		  result = FAIL;
		  goto endRead;
		}
	  }
	  if (AddLineToTextBlock (block, mybuf) == FAIL)
		break;
	  if (hCodedBlockWnd && currentCoded) {
		currentCoded->numLines++;
		currentCoded->numBytes += numRead;
		if (currentCoded->numLines % STATUS_UPDATE_FREQ == 0)
		  UpdateBlockStatus ();
	  }
	}
  }

endRead:;
  MRRCloseFile (MRRFile);
  CodingState = INACTIVE;
  return (result);
}

/* ------------------------------------------------------------------------
 * ReplaceLineInTextBlock
 * This is ugly, and really inefficient of the textblock is big
 * 1. If newline has length > oldline, then make sure text array has enough
 *    room, then shift right the string starting at the end of oldline by 
 *    n characters where n is len(newline)-len(oldline)
 * 2. If newline has length < oldline then shift the string starting at the
 *    end of oldline by n characters where n is len(oldline)-len(newline)
 * 3. If oldline and newline are same length, do no shifting
 * 4. Then copy in the new string
 * 5. Adjust all affected offsets (the lines after this one) by size diff
 * 6. God this is ugly, hope we don't use it much!
 */
BOOL
ReplaceLineInTextBlock (TypTextBlock * textBlock, unsigned long num, char *line)
{
  unsigned int newLen, oldLen;
  int sizeDiff;
  register char huge *dst, *src;
  register unsigned long i;

  if (line == NULL || *line == '\0')
	return (SUCCESS);

  newLen = strlen (line) + 1;
  oldLen = strlen (TextBlockLine (textBlock, num)) + 1;
  sizeDiff = newLen - oldLen;

  if (sizeDiff > 0)				// new line longer than old line
   {
	// increase text array size if necessary
	if (textBlock->numBytes + sizeDiff > textBlock->maxBytes) {
	  textBlock->maxBytes *= 2;
	  if ((textBlock->text = (char huge *) GlobalReAllocPtr (textBlock->text,
			 textBlock->maxBytes * sizeof (char), GMEM_MOVEABLE)) == NULL) {
		MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Add", MB_OK);
		return (FAIL);
	  }
	}
	// shift the text array right by sizeDiff chars
	// sizeDiff iterations, walking backwards from end
	for (src = textBlock->text + textBlock->numBytes,
		 dst = src + sizeDiff;;
		 dst--, src--) {
	  *dst = *src;
	  if (src == TextBlockLine (textBlock, num))
		break;
	}

  }
  else if (sizeDiff < 0)
	// shift the text array left by sizeDiff chars
	// numBytes - &oldline iterations, walking forwards
	for (src = TextBlockLine (textBlock, num) + oldLen,
		 dst = src + sizeDiff;
		 dst < &textBlock->text[textBlock->numBytes + 1];
		 dst++, src++)
	  *dst = *src;

  // adjust all affected offsets (lines after this line)
  if (sizeDiff != 0)
	for (i = num + 1; i < textBlock->numLines; i++)
	  textBlock->offset[i] += sizeDiff;

  textBlock->numBytes += sizeDiff;

  // save max string len for use in scroll bar ranges in status wnd
  if (newLen > textBlock->maxLineLen)
	textBlock->maxLineLen = newLen;

  // copy it in, including the NULL
  memcpy (TextBlockLine (textBlock, num), line, newLen);

  return (SUCCESS);
}
@


1.8
log
@reindented
@
text
@d13 1
d15 1
a15 23
 * $Id: wvtxtblk.c 1.7 1994/11/09 23:01:00 rushing Exp rushing $
 * $Log: wvtxtblk.c $
 * Revision 1.7  1994/11/09  23:01:00  rushing
 * 93.3 update
 *
 * Revision 1.6  1994/11/02  01:51:44  jcooper
 * Initial revision
 * 
 * Revision 1.5  1994/09/18  22:42:58  jcooper
 * Added IsBusy flag
 * 
 * Revision 1.4  1994/09/16  01:12:35  jcooper
 * general cleanup for 92.6
 * 
 * Revision 1.3  1994/08/11  00:11:55  jcooper
 * Changes to author mail address
 *
 * Revision 1.2  1994/05/23  18:36:00  jcooper
 * new attach code, session [dis]connect
 *
 * Revision 1.1  1994/01/16  12:12:47  jcoop
 * Initial revision
 *
d17 1
@


1.7
log
@93.3 update
@
text
@d14 1
a14 1
 * $Id: wvtxtblk.c 1.6 1994/11/02 01:51:44 jcooper Exp $
d16 3
d52 2
a53 2
BOOL IncreaseTextSize (TypTextBlock *textBlock, unsigned long inc);
BOOL AllocTextBlock (TypTextBlock *textBlock, unsigned long bytes, unsigned long lines);
d56 2
a57 2
 * 	Mem Management routines for text block
 *	This is my simple alternative M. Riordan's Doc paradigm
d60 1
a60 1
AllocTextBlock (TypTextBlock *textBlock, unsigned long bytes, unsigned long lines)
d62 16
a77 18
	textBlock->maxLines = lines;
	if ((textBlock->offset = (unsigned long huge *) GlobalAllocPtr (GMEM_MOVEABLE, textBlock->maxLines * sizeof (unsigned long huge))) == NULL)
	{
//		MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Create-Offsets", MB_OK);
		return (FAIL);
	}
	textBlock->numLines = 0;

	textBlock->maxBytes = bytes;
	if ((textBlock->text = (char huge *) GlobalAllocPtr (GMEM_MOVEABLE, textBlock->maxBytes * sizeof (char huge))) == NULL)
	{
//		MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Create-Text", MB_OK);
		GlobalFreePtr(textBlock->offset);
		return (FAIL);
	}
	textBlock->numBytes = 0;
	textBlock->maxLineLen = 0;
	return (SUCCESS);
d87 15
a101 16
	TypTextBlock *textBlock;
        
	if ((textBlock = (TypTextBlock *) GlobalAllocPtr (GMEM_MOVEABLE, sizeof (TypTextBlock)))==NULL)
	{
		MessageBox (hParentWnd, "Memory Allocation Failure", "Text Block Create-Block", MB_OK);
		return (NULL);
	}
	textBlock->hTextWnd = hParentWnd;
	textBlock->IsBusy = TRUE;
	if (AllocTextBlock(textBlock, bytes, lines) == FAIL) {
		GlobalFreePtr(textBlock);
		return (NULL);
	}
	
	return (textBlock);
}	 
d104 1
a104 1
InitTextBlock (HWND hParentWnd) 
d106 9
a114 9
	TypTextBlock *textBlock;
	
	if ((textBlock = InitTextBlockWithSize (hParentWnd, TEXT_SIZE_INC, BLOCK_NUM_LINES_INC)) == NULL) {
		MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Creation", MB_OK);
		return (NULL);
	}
	
	return (textBlock);
}	 
d117 1
a117 1
ResetTextBlock (TypTextBlock *textBlock) 
d119 4
a122 4
	GlobalFreePtr (textBlock->text);
	GlobalFreePtr (textBlock->offset);
	AllocTextBlock(textBlock, TEXT_SIZE_INC, BLOCK_NUM_LINES_INC);
}	 
d125 1
a125 1
FreeTextBlock (TypTextBlock *textBlock)
d127 3
a129 3
	GlobalFreePtr (textBlock->text);
	GlobalFreePtr (textBlock->offset);
	GlobalFreePtr (textBlock);
d133 32
a164 19
AddLineToTextBlock (TypTextBlock *textBlock, char *line)
{		
	unsigned int len;
	unsigned long nextSeg;

	if (line == NULL || *line == '\0')
		return (SUCCESS);

	// manage offset list
	if (textBlock->numLines + 1 >= textBlock->maxLines)
	{
		textBlock->maxLines += BLOCK_NUM_LINES_INC;
		if ((textBlock->offset = (unsigned long huge *) GlobalReAllocPtr (textBlock->offset,
	   		     textBlock->maxLines * sizeof (unsigned long huge), GMEM_MOVEABLE)) == NULL)
		{
			MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Add-Offsets", MB_OK);
			return (FAIL);
		}
	}
d166 18
a183 32
	// manage text string
	len = strlen (line) + 1;	// include the NULL in the count
	if (textBlock->numBytes + len >= textBlock->maxBytes)
		if (IncreaseTextSize (textBlock, max(len, TEXT_SIZE_INC)) == FAIL)
			return (FAIL);
		
	// check if this line would cause text to cross a 64k segment
	// if so, fill in with nulls, and start new line at next seg 
	// WHY DO I HAVE TO DO THIS?!?!? Windows is supposed to take
	// care of this isn't it?!  memcpy is supposed to work with huge
	nextSeg = ((textBlock->numBytes + 65536L) / 65536L) * 65536L;
	if (textBlock->numBytes + len > nextSeg) 
	{
	   if (nextSeg + len > textBlock->maxBytes)	// do we need to add some space?
	   	if (IncreaseTextSize (textBlock, max(nextSeg-textBlock->numBytes, TEXT_SIZE_INC)) == FAIL)
			return (FAIL);
	   while (textBlock->numBytes < nextSeg)
		textBlock->text[(textBlock->numBytes)++] = '\0';
	}	
        // set pointer offset to this new string
        textBlock->offset[textBlock->numLines] = textBlock->numBytes;
        
        // copy it in, including the NULL
	memcpy ((char huge *) &(textBlock->text[textBlock->numBytes]), line, len);

        // increment counters
	textBlock->numLines++;
	textBlock->numBytes += (unsigned long)len;
	
	// save max string len for use in scroll bar ranges in status wnd
	if (len > textBlock->maxLineLen)
		textBlock->maxLineLen = len;
d185 1
a185 1
	return (SUCCESS);
d189 1
a189 1
IncreaseTextSize (TypTextBlock *textBlock, unsigned long inc)
d191 6
a196 7
	textBlock->maxBytes += inc;
	if ((textBlock->text = (char huge *) GlobalReAllocPtr (textBlock->text,
   		     textBlock->maxBytes * sizeof (char huge), GMEM_MOVEABLE)) == NULL)
	{
		MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Add-Text", MB_OK);
		return (FAIL);
	}
d203 1
a203 1
 */                   
d205 1
a205 1
AddEndedLineToTextBlock (TypTextBlock *textBlock, char *line)
d207 22
a228 22
	char *new, *ptr;
	unsigned int len;
	BOOL result;
	
	len = strcspn (line, "\n\r");
	ptr = new = (char *) GlobalAllocPtr (GMEM_MOVEABLE, (len+4) * sizeof(char));
	if (ptr == NULL) {
		return (FAIL);
	}
//	if (mode == ADD_TO_POST && line[0] == '.')
//		*(ptr++) = '.';

	if (len > 0)
		memcpy (ptr, line, len);
		
	ptr[len++] = '\r';
	ptr[len++] = '\n';
	ptr[len] = '\0';

	result = AddLineToTextBlock (textBlock, new);
	GlobalFreePtr (new);
	return (result);
d237 1
a237 1
ReadFileToTextBlock (HWND hParentWnd, TypTextBlock *block, char *fileName)
d239 33
a271 48
	register int i;
	TypMRRFile *MRRFile;
	HFILE hFile;
	int numRead, result;
	char mybuf[TEMPBUFSIZE];
	BOOL leadingBlanks;
	
	hFile = MRROpenFile (fileName, OF_READ, &MRRFile);
	if (hFile <= 0)
	{
		sprintf(str, "Could not open file %s for read", fileName);
		MessageBox (hParentWnd, str, "Open File Error", MB_OK);
		return (FAIL);
	}
	else
	{
		CodingState = ATTACH_READFILE;
		leadingBlanks = TRUE;
		result = SUCCESS;
		while ((numRead = MRRReadLine (MRRFile, mybuf, TEMPBUFSIZE)) > -1)
		{
			mybuf[numRead] = '\0';
			if (leadingBlanks)	{ // skip leading blank lines
			  if (IsBlankStr (mybuf))
			  	continue;
			  else
			  	leadingBlanks = FALSE;
			}
			  	
			for (i = 0; i < numRead; i++)
			{
			  if (!__isascii (mybuf[i]))
			  {
				sprintf(str, "File %s appears to contain non-ASCII data.\nBinary files must be encoded for attachment", fileName);
				MessageBox (hParentWnd, str, "Non-ASCII File Error", MB_OK);
				result = FAIL;
				goto endRead;
			  }
			}
			if (AddLineToTextBlock (block, mybuf) == FAIL)
				break;
			if (hCodedBlockWnd && currentCoded)
			{
				currentCoded->numLines++;
				currentCoded->numBytes+=numRead;
				if (currentCoded->numLines % STATUS_UPDATE_FREQ == 0)
					UpdateBlockStatus ();
			}
d273 16
a288 6
	}

    endRead:;
	MRRCloseFile (MRRFile);
	CodingState = INACTIVE;
	return (result);
d303 1
a303 1
 */                   
d305 24
a328 38
ReplaceLineInTextBlock (TypTextBlock *textBlock, unsigned long num, char *line)
{		
	unsigned int newLen, oldLen;
	int sizeDiff;
        register char huge *dst, *src;
	register unsigned long i;        
	
	if (line == NULL || *line == '\0')
		return (SUCCESS);
		
	newLen = strlen (line) + 1;
	oldLen = strlen(TextBlockLine(textBlock, num)) + 1;
	sizeDiff = newLen - oldLen;
	
	if (sizeDiff > 0)	// new line longer than old line
	{
		// increase text array size if necessary
		if (textBlock->numBytes + sizeDiff > textBlock->maxBytes)
		{
			textBlock->maxBytes *= 2;
			if ((textBlock->text = (char huge *) GlobalReAllocPtr (textBlock->text,
		   		     textBlock->maxBytes * sizeof (char), GMEM_MOVEABLE)) == NULL)
			{
				MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Add", MB_OK);
				return (FAIL);
			}
		}
		// shift the text array right by sizeDiff chars
		// sizeDiff iterations, walking backwards from end
		for (src = textBlock->text + textBlock->numBytes,
		     dst = src + sizeDiff;;
		     dst--, src--)
		{			
			*dst = *src; 
		     	if (src == TextBlockLine(textBlock, num))
		     		break;
		}
		     
d330 33
a362 22
	else if (sizeDiff < 0)
		// shift the text array left by sizeDiff chars
		// numBytes - &oldline iterations, walking forwards
		for (src = TextBlockLine(textBlock, num) + oldLen,
		     dst = src + sizeDiff;
		     dst < &textBlock->text[textBlock->numBytes + 1];
		     dst++, src++)
			*dst = *src;
	
	// adjust all affected offsets (lines after this line)
	if (sizeDiff != 0)
		for (i = num + 1; i < textBlock->numLines; i++)
			textBlock->offset[i] += sizeDiff;
	
	textBlock->numBytes += sizeDiff;

	// save max string len for use in scroll bar ranges in status wnd
	if (newLen > textBlock->maxLineLen)
		textBlock->maxLineLen = newLen;
				
        // copy it in, including the NULL
	memcpy (TextBlockLine(textBlock, num), line, newLen);
d364 1
a364 1
	return (SUCCESS);
@


1.6
log
@Initial revision
@
text
@d14 1
a14 1
 * $Id: wvtxtblk.c 1.5 1994/09/18 22:42:58 jcooper Exp $
d16 3
@


1.5
log
@Added IsBusy flag
@
text
@d14 1
a14 1
 * $Id: wvtxtblk.c 1.4 1994/09/16 01:12:35 jcooper Exp $
d16 3
d42 2
a43 2
#define BLOCK_NUM_LINES_INC	64
#define TEXT_SIZE_INC		1024
d47 1
a47 1
BOOL AllocTextBlock (TypTextBlock *textBlock);
d53 27
d81 1
a81 1
InitTextBlock (HWND hParentWnd) 
d87 1
a87 1
		MessageBox (hParentWnd, "Memory Allocation Failure", "Text Block Create-Block", ID_OK);
d92 2
a93 1
	if (AllocTextBlock(textBlock) == FAIL)
d95 1
d100 13
d118 1
a118 1
	AllocTextBlock(textBlock);
a120 21
BOOL
AllocTextBlock (TypTextBlock *textBlock)
{
	textBlock->maxLines = BLOCK_NUM_LINES_INC;
	if ((textBlock->offset = (unsigned long huge *) GlobalAllocPtr (GMEM_MOVEABLE, textBlock->maxLines * sizeof (unsigned long huge))) == NULL)
	{
		MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Create-Offsets", ID_OK);
		return (FAIL);
	}
	textBlock->numLines = 0;

	textBlock->maxBytes = TEXT_SIZE_INC;
	if ((textBlock->text = (char huge *) GlobalAllocPtr (GMEM_MOVEABLE, textBlock->maxBytes * sizeof (char huge))) == NULL)
	{
		MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Create-Text", ID_OK);
		return (FAIL);
	}
	textBlock->numBytes = 0;
	textBlock->maxLineLen = 0;
	return (SUCCESS);
}
d145 1
a145 1
			MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Add-Offsets", ID_OK);
d193 1
a193 1
		MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Add-Text", ID_OK);
d204 1
a204 1
AddEndedLineToTextBlock (TypTextBlock *textBlock, char *line, int mode)
d212 5
a216 2
	if (mode == ADD_TO_POST && line[0] == '.')
		*(ptr++) = '.';
d221 2
a222 14
	switch (mode)
	{
	case ADD_TO_POST:
		ptr[len++] = '\r';	
		break;
	case ADD_TO_EDIT:
	case ADD_TO_FILE:
		ptr[len++] = '\r';	// to edit buf
		ptr[len++] = '\n';
		break;
//	case ADD_TO_FILE:
//		ptr[len++] = '\n';
//		break;
	}	
d224 1
a224 1
	
a226 1
	
d236 1
a236 1
ReadFileToTextBlock (HWND hParentWnd, TypTextBlock *block, char *fileName, int mode)
d260 1
a260 1
			if (leadingBlanks)	// skip leading blanks
d265 1
d267 1
a267 1
       			for (i = 0; i < numRead; i++)
d277 1
a277 1
			if (AddEndedLineToTextBlock (block, mybuf, mode) == FAIL)
d279 1
a279 1
			if (hCodedBlockWnd != (HWND)NULL)
d283 2
a284 2
			    	if (currentCoded->numLines % STATUS_UPDATE_FREQ == 0)
			    		UpdateBlockStatus ();
d332 1
a332 1
				MessageBox (textBlock->hTextWnd, "Memory Allocation Failure", "Text Block Add", ID_OK);
@


1.4
log
@general cleanup for 92.6
@
text
@d14 1
a14 1
 * $Id: wvtxtblk.c 1.3 1994/08/11 00:11:55 jcooper Exp $
d16 3
d61 1
@


1.3
log
@Changes to author mail address
@
text
@d14 1
a14 1
 * $Id: wvtxtblk.c 1.2 1994/05/23 18:36:00 jcooper Exp $
d16 3
d26 5
a32 2
#include <windows.h>
#include <windowsx.h>
a34 2
#include "wvglob.h"
#include "winvn.h"
d222 1
a222 1
	HANDLE hRetCode;
d227 2
a228 2
	hRetCode = MRROpenFile (fileName, OF_READ, &MRRFile);
	if ((int) hRetCode <= 0)
@


1.2
log
@new attach code, session [dis]connect
@
text
@d10 1
a10 1
 * Author: John S. Cooper (jcoop@@apl.com)                           *
d14 1
a14 1
 * $Id: wvtxtblk.c 1.1 1994/01/16 12:12:47 jcoop Exp $
d16 3
@


1.1
log
@Initial revision
@
text
@d14 5
a18 2
 * $Id:  $
 * $Log:  $
d165 1
a165 3
 * to \n\r if posting to EditWnd, to \r if posting to net, or to \n if
 * posting to dos file
 * Also, if Attaching and first char is '.', change it to '..'
d171 1
a171 1
	char *new;
d176 3
a178 3
	new = (char *) GlobalAllocPtr (GMEM_MOVEABLE, (len+4) * sizeof(char));
	if (Attaching && line[0] == '.')
		new[len++] = '.';
d181 1
a181 1
		memcpy (new, line, len);
d186 1
a186 1
		new[len++] = '\r';	// \r if posting to net OR edit buf
d190 2
a191 2
		new[len++] = '\r';	// to edit buf
		new[len++] = '\n';
d194 1
a194 1
//		new[len++] = '\n';
d197 1
a197 1
	new[len] = '\0';
@
