#! /usr/local/bin/python
# grabs version strings out of source files,
# creates the source file 'version.c'

import sys
import os
import regex
import regsub

# example: $Id: winvn.c 1.57 1994/11/09 23:02:03 rushing Exp $
version_reg = regex.compile('.*\$Id: \(.*\) Exp \$.*')

strings = []

def usage ():
	print 'version.py file ...'

if len(sys.argv) < 2:
	usage()
	sys.exit()
	
def find_version (filename):
	fin = open(filename, 'r')
	vstr = ''
	while 1:
		line = fin.readline()
		if line == '':
			break
		if version_reg.match(line) != -1:
			vstr = version_reg.group(1)
			vstr = regsub.gsub(' ', '\t', vstr)
			break
	fin.close()
	return vstr

try:
	fout = open ('version.c', 'w')
except IOError:
	print "Couldn't open version.c for output"
	sys.exit()
	
fout.write('static char * version_string[] = {\n')
print 'grabbing version strings...'

for x in sys.argv[1:]:
	print x + '...'
	vstr = find_version(x)
	if vstr != '':
		fout.write('"'+find_version(x)+'"\n')

fout.write('};\n')
